type Souvenir = Record
	Title			: String;	//Titulek
	Information		: String;	//Informace o suvenru
	SGuid			: String;	//GUID
	SID				: String;	//ID
	SType			: String;	//Typ
	ImageUrl		: String;	//Adresa obrzku - velkho
	ImageThumbUrl	: String;	//Adresa obrzku - malho
	DateDiscovered	: String;	//Kdy zskno
	DateRange		: String;	//Rozsah platnosti
end;

const
	CalcGSAPI_Version = '1.0.3';
	CalcGSAPI_sModuleTmp = '\Stator\Tmp\';

var
	CalcGS_Souvenirs: array of Souvenir;		//Pole suvenr
	
//uvolnovaci funkce modulu
procedure CalcGSAPI_Free;
begin
  Log('Start CalcGSAPI__Free()');
end;
//
//dateparse
function CalcGSAPI_DateParse(Const sd:String):String;
var
	s,y,m,d:String;
begin
	if sd = '' then Result:=sd
	else begin
		s:=sd;
		y:=Fetch(s,'-');
		m:=Fetch(s,'-');
		d:=Fetch(s,'T');
		Result:=d+'.'+m+'.'+y;
	end;
end;
//
//Pevede '' na '0'
function CalcGSAPI_NullToZero(s:String):String;
begin
	if s = '' then Result:='0'
	else Result:=s;
end;
//
//Projede typy a spot z nich poty
function CalcGSAPI_CountByTypes(Const e:TJclSimpleXMLElem):String;
var
	i,j:integer;
	se,sse:TJclSimpleXMLElem;
	cnt:integer;
begin
	cnt := 0;
	if e.Items.count > 0 then begin
		for i:=0 to e.Items.count-1 do begin
			se := e.Items[i];
			for j:=0 to se.Items.count-1 do begin
				sse := se.Items[j];
				if sse.name = 'UserCount' then cnt := cnt + StrToInt(sse.value);
			end;
		end;
	end;
	//else Log('sssE: no Type elements');
	//
	//Log('ssEX: ' + IntToStr(cnt));
	Result:=IntToStr(cnt);
end;
//
//Hodnota SubElementu jmno 'seName'
function CalcGSAPI_GetSubElementValue(Const e:TJclSimpleXMLElem; Const seName:String):String;
var
	i:integer;
	se:TJclSimpleXMLElem;
	res:String;
begin
	res:='';
	if e.Items.count > 0 then begin
		for i:=0 to e.Items.count-1 do begin
			se := e.Items[i];
			if se.name = seName then res:=se.value;
		end;
	end;
	//else Log('sssE: no Type elements');
	//
	Result:=res;
end;
//
//Poty TB
function CalcGSAPI_GetTBCount(Const e:TJclSimpleXMLElem):integer;
var
	i:integer;
	se:TJclSimpleXMLElem;
begin
	Result:=0;
	if e.Items.count > 0 then begin
		for i:=0 to e.Items.count-1 do begin
			se := e.Items[i];
			if CalcGSAPI_GetSubElementValue(se,'TBTypeName') = 'Travel Bug Dog Tags' then begin
				Result:=StrToInt(CalcGSAPI_GetSubElementValue(se,'UserCount'));
				break;
			end;
		end;
	end;
	//else Log('sssE: no Type elements');
end;

//
//Parsuje sekci FavoritePoints
procedure CalcGSAPI_ParseFP(Const e:TJclSimpleXMLElem);
var
	i:integer;
	se:TJclSimpleXMLElem;
begin
	for i:=0 to e.Items.count-1 do begin
		se := e.Items[i];
		//Log('ssE: ' + se.name + ' - ' + CalcGSAPI_NullToZero(se.value));
		Case se.name of
			'PercentCompleteTowardsNextPoint': 	GlobalVarSet('CalcGS_FPPercentCompletedToNextPoint',CalcGSAPI_NullToZero(se.value));
			'PointsAvailable': 					GlobalVarSet('CalcGS_FPPointsAvailable',CalcGSAPI_NullToZero(se.value));		
			'TotalPoints': 						GlobalVarSet('CalcGS_FPTotalPoints',CalcGSAPI_NullToZero(se.value));	
			'TotalUntilNextPoint': 				GlobalVarSet('CalcGS_FPTotalUntilNextPoint',CalcGSAPI_NullToZero(se.value));
		end;
	end;	
end;
//
//Parsuje sekci Geocaches
procedure CalcGSAPI_ParseCaches(Const e:TJclSimpleXMLElem);
var
	i:integer;
	cFind,cFindByType:integer;
	se:TJclSimpleXMLElem;
begin
	for i:=0 to e.Items.count-1 do begin
		se := e.Items[i];
		//Log('ssE: ' + se.name + ' - ' + CalcGSAPI_NullToZero(se.value));
		Case se.name of
			'BenchmarkFindTypes':	GlobalVarSet('CalcGS_GeocachesBenchmarkCountByType',CalcGSAPI_CountByTypes(se));
			'GeocacheFindTypes':	begin
				cFindByType:=StrToInt(CalcGSAPI_CountByTypes(se));
				GlobalVarSet('CalcGS_GeocachesFindCountByType',IntToStr(cFindByType));
			end;
			'GeocacheFindCount':	begin
				cFind:=StrToInt(CalcGSAPI_NullToZero(se.value));
				GlobalVarSet('CalcGS_GeocachesFindCount',CalcGSAPI_NullToZero(se.value));
			end;
			'GeocacheHideTypes': 	GlobalVarSet('CalcGS_GeocachesHideCountByType',CalcGSAPI_CountByTypes(se));
			'GeocacheHideCount':	GlobalVarSet('CalcGS_GeocachesHideCount',CalcGSAPI_NullToZero(se.value));
		end;
	end;
	//Zaloeno zatm jen na rozdlu vpotu podle typu a celkovho potu ke
	//-----------------------------------------------------------------------
	GlobalVarSet('CalcGS_GeocachesLABCount',IntToStr(cFind-cFindByType));
	//-----------------------------------------------------------------------
end;
//
//Parsuje sekci Profil
{procedure CalcGSAPI_ParseProfile(Const e:TJclSimpleXMLElem);
var
	i:integer;
	se:TJclSimpleXMLElem;
begin
	for i:=0 to e.Items.count-1 do begin
		se := e.Items[i];
		//if se.name<>'PublicProfile' then Log('ssE: ' + se.name + ' - ' + CalcGSAPI_NullToZero(se.value));
		Case se.name of
			'ForumTitle':	GlobalVarSet('CalcGS_ProfileRole',se.value);
			'MemberSince':	GlobalVarSet('CalcGS_ProfileMemberSince', CalcGSAPI_DateParse(se.value));
			'ProfilePhoto':	GlobalVarSet('CalcGS_ProfileProfilePhotoUrl',CalcGSAPI_GetSubElementValue(se,'PhotoUrl'));
		end;
	end;
end;}
//
//Parsuje sekci Souvenirs
procedure CalcGSAPI_ParseSouvenirs(Const e:TJclSimpleXMLElem);
var
	i,j:integer;
	se,sse:TJclSimpleXMLElem;
	sds,sde:String;
	aList:TStringList;
begin
	aList:=TStringList.Create(); aList.Sorted:=true;
	try
		GlobalVarSet('CalcGS_SouvenirsCount',IntToStr(e.Items.count));
		if e.Items.count > 0 then begin
			//
			SetLength(CalcGS_Souvenirs, e.Items.count);				//nastavi pole suvenr
			//
			for i:=0 to e.Items.count-1 do begin
				se := e.Items[i];
				sds:=''; sde:='';
				for j:=0 to se.Items.count-1 do begin
					sse := se.Items[j];
					Case sse.name of
						'Title': begin CalcGS_Souvenirs[i].Title:=sse.value; aList.Add(UtfToAnsi(sse.value)); end;
						'Information': CalcGS_Souvenirs[i].Information:=sse.value;
						'SouvenirGuid': CalcGS_Souvenirs[i].SGuid:=sse.value;
						'SouvenirID':  CalcGS_Souvenirs[i].SID:=sse.value;
						'SouvenirType': CalcGS_Souvenirs[i].SType:=sse.value;
						'ImagePath': CalcGS_Souvenirs[i].ImageUrl:=sse.value;
						'ThumbPath': CalcGS_Souvenirs[i].ImageThumbUrl:=sse.value;
						'DateDiscovered': CalcGS_Souvenirs[i].DateDiscovered:=CalcGSAPI_DateParse(sse.value);
						'DateRangeStart': sds:=sse.value;
						'DateRangeEnd': sde:=sse.value;
					end;
				end;
				CalcGS_Souvenirs[i].DateRange:=Trim(CalcGSAPI_DateParse(sds)+' - '+CalcGSAPI_DateParse(sde));
			end;
			GlobalVarSet('CalcGS_Souvenirs',ReplaceString(Trim(aList.Text),CRLF,' | '));
		end;
	finally
		aList.Free();
	end;
end;
//
//Parsuje sekci Stats
procedure CalcGSAPI_ParseStats(Const e:TJclSimpleXMLElem);
var
	i:integer;
	se:TJclSimpleXMLElem;
begin
	for i:=0 to e.Items.count-1 do begin
		se := e.Items[i];
		//Log('ssE: ' + se.name + ' - ' + CalcGSAPI_NullToZero(se.value));
		Case se.name of
			'ActiveCaches':	GlobalVarSet('CalcGS_StatActiveCaches',CalcGSAPI_NullToZero(se.value));
			'ActiveCountries':	GlobalVarSet('CalcGS_StatActiveCountries',CalcGSAPI_NullToZero(se.value));
		end;
	end;
end;
//
//Parsuje sekci Trackable
procedure CalcGSAPI_ParseTrackables(Const e:TJclSimpleXMLElem);
var
	i,nTB,nGC,nAll:integer;
	se:TJclSimpleXMLElem;
begin
	for i:=0 to e.Items.count-1 do begin
		se := e.Items[i];
		//Log('ssE: ' + se.name + ' - ' + CalcGSAPI_NullToZero(se.value));
		Case se.name of
			'TrackableFindCount':	begin
				nAll:=StrToInt(CalcGSAPI_NullToZero(se.value));
				GlobalVarSet('CalcGS_TrackablesFoundCount',IntToStr(nAll));
			end;
			'TrackableFindTypes':	begin
				GlobalVarSet('CalcGS_TrackablesFindTypeCount',CalcGSAPI_NullToZero(IntToStr(se.Items.count)));
				GlobalVarSet('CalcGS_TrackablesFoundCountByType',CalcGSAPI_CountByTypes(se));
				nTB:=CalcGSAPI_GetTBCount(se);
			end;
			'TrackableOwnedCount': 	GlobalVarSet('CalcGS_TrackablesOwnedCount',CalcGSAPI_NullToZero((se.value)));
			'TrackableOwnedTypes':	begin
				GlobalVarSet('CalcGS_TrackablesOwnedTypeCount',CalcGSAPI_NullToZero(IntToStr(se.Items.count)));
				GlobalVarSet('CalcGS_TrackablesOwnedCountByType',CalcGSAPI_CountByTypes(se));
			end;
		end;
	end;
	nGC:=nAll-nTB;
	GlobalVarSet('CalcGS_TrackablesTBCount',IntToStr(nTB));
	GlobalVarSet('CalcGS_TrackablesGCCount',IntToStr(nGC));
end;
//
//Parsuje sekci User
procedure CalcGSAPI_ParseUser(Const e:TJclSimpleXMLElem);
var
	i:integer;
	se:TJclSimpleXMLElem;
begin
	for i:=0 to e.Items.count-1 do begin
		se := e.Items[i];
		//Log('ssE: ' + se.name + ' - ' + CalcGSAPI_NullToZero(se.value));
		Case se.name of
			'AvatarUrl':		GlobalVarSet('CalcGS_UserAvatarUrl',se.value);
			'FindCount':		GlobalVarSet('CalcGS_UserFindCount',CalcGSAPI_NullToZero(se.value));
			'GalleryImageCount':GlobalVarSet('CalcGS_UserGalleryImagesCount',CalcGSAPI_NullToZero(se.value));
			'HideCount':		GlobalVarSet('CalcGS_UserHideCount',CalcGSAPI_NullToZero(se.value));
			'HomeCoordinates':	GlobalVarSet('CalcGS_UserHomeCoordinates',CalcGSAPI_GetSubElementValue(se,'Latitude')
										+'|'+CalcGSAPI_GetSubElementValue(se,'Longitude'));
			'Id':				GlobalVarSet('CalcGS_UserID',se.value);
			'MemberType':		GlobalVarSet('CalcGS_UserMemberType',CalcGSAPI_GetSubElementValue(se,'MemberTypeName'));
			'PublicGuid':		GlobalVarSet('CalcGS_UserPublicGuid',se.value);
			'UserName':			GlobalVarSet('CalcGS_UserName',se.value);
		end;
	end;
end;

function CalcGSAPI_GetSouvenirsData(aParam:TStringList):String;
var
	i: integer;
	Title, SSType, Option, Width: String;
	Isok: boolean;
begin
	Result := ''; SSType := ''; Option := '';Isok:=false;
	if(aParam<>nil) then begin
		For i := 0 to aParam.Count-1 do begin
			//Log('PIDX:'+IntToStr(i));
			if Pos('TITLE',Uppercase(aParam[i])) > 0  then 
				Title := ReplaceString(aParam[i],Copy(aParam[i],1,5)+':','');
			if Pos('TYPE',Uppercase(aParam[i])) > 0  then 
				SSType := ReplaceString(aParam[i],Copy(aParam[i],1,4)+':','');
			if Pos('OPTION',Uppercase(aParam[i])) > 0  then 
				Option := ReplaceString(aParam[i],Copy(aParam[i],1,6)+':','');
			if Pos('WIDTH',Uppercase(aParam[i])) > 0  then 
				Width := ReplaceString(aParam[i],Copy(aParam[i],1,5)+':','');
		end;
		For i := 0 to High(CalcGS_Souvenirs) do begin
			//Log('IDX:'+IntToStr(i));
			if Uppercase(Trim(UtfToAnsi(CalcGS_Souvenirs[i].Title))) = Uppercase(Title) then begin
				Isok:=true;
				break;	
			end;
		end;
		if Isok then begin
			case Uppercase(Option) of
				'URL'	: begin
					if Uppercase(SSType) = 'BIG' then
						Result := CalcGS_Souvenirs[i].ImageUrl
					else
						Result := CalcGS_Souvenirs[i].ImageThumbUrl;
				end;
				'INFO'	:Result := UtfToAnsi(CalcGS_Souvenirs[i].Information);
				else begin
					if Uppercase(SSType) = 'BIG' then
						Result := '<a href="https://www.geocaching.com/souvenir/?guid='+CalcGS_Souvenirs[i].SGuid+'" target="_blank"><img src="'+CalcGS_Souvenirs[i].ImageUrl + '" width="' + ReplaceString(Width,'%','') +'" title="'+UtfToAnsi(CalcGS_Souvenirs[i].Title)+' ('+CalcGS_Souvenirs[i].DateDiscovered+')" style="max-height:480px;max-width:480px;" /></a>'
					else
						Result := '<a href="https://www.geocaching.com/souvenir/?guid='+CalcGS_Souvenirs[i].SGuid+'" target="_blank"><img src="'+CalcGS_Souvenirs[i].ImageThumbUrl + '" width="' + ReplaceString(Width,'%','') +'" title="'+UtfToAnsi(CalcGS_Souvenirs[i].Title)+' ('+CalcGS_Souvenirs[i].DateDiscovered+')" style="max-height:100px;max-width:100px;" /></a>';
				end;
			end;
		end;
	end;
end;

//hlavni funkce modulu
function CalcGSAPI_Run(aPar:TStringList):string;
var
	sxmlData, sxmlRes, s, f, msg: String;
	i,j,n,m: integer;
	Xml: TJclSimpleXML;
	e, se: TJclSimpleXMLElem;  	//subelement
	dt: TDateTime;
begin
	Result:='';
	//----------------------------------------------------------------------------------------------
	//registrovat fce
	GlobalVarRegisterReplaceFunction('CalcGSAPI_GetSouvenirsData',@CalcGSAPI_GetSouvenirsData);
	//----------------------------------------------------------------------------------------------
	Log('Start CalcGSAPI_Run()');
	sxmlData := '<GetYourUserProfileRequest xmlns="http://www.geocaching.com/Geocaching.Live/data">' + CRLF;
	sxmlData := sxmlData + '<AccessToken>String content</AccessToken>' + CRLF;
	sxmlData := sxmlData + '<ProfileOptions>' + CRLF;
	sxmlData := sxmlData + '<ChallengesData xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">false</ChallengesData>' + CRLF;
	sxmlData := sxmlData + '<FavoritePointsData xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">true</FavoritePointsData>' + CRLF;
	sxmlData := sxmlData + '<GeocacheData xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">true</GeocacheData>' + CRLF;
	sxmlData := sxmlData + '<PublicProfileData xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">false</PublicProfileData>' + CRLF;
	sxmlData := sxmlData + '<SouvenirData xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">true</SouvenirData>' + CRLF;
	sxmlData := sxmlData + '<TrackableData xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">true</TrackableData>' + CRLF;
	sxmlData := sxmlData + '<EmailData xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">false</EmailData>' + CRLF;
	sxmlData := sxmlData + '</ProfileOptions>' + CRLF;
	sxmlData := sxmlData + '<DeviceInfo>' + CRLF;
	sxmlData := sxmlData + '<ApplicationCurrentMemoryUsage xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">2147483647</ApplicationCurrentMemoryUsage>' + CRLF;
	sxmlData := sxmlData + '<ApplicationPeakMemoryUsage xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">2147483647</ApplicationPeakMemoryUsage>' + CRLF;
	sxmlData := sxmlData + '<ApplicationSoftwareVersion xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">String content</ApplicationSoftwareVersion>' + CRLF;
	sxmlData := sxmlData + '<DeviceManufacturer xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">String content</DeviceManufacturer>' + CRLF;
	sxmlData := sxmlData + '<DeviceName xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">String content</DeviceName>' + CRLF;
	sxmlData := sxmlData + '<DeviceOperatingSystem xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">String content</DeviceOperatingSystem>' + CRLF;
	sxmlData := sxmlData + '<DeviceTotalMemoryInMB xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">1.26743233E+15</DeviceTotalMemoryInMB>' + CRLF;
	sxmlData := sxmlData + '<DeviceUniqueId xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">String content</DeviceUniqueId>' + CRLF;
	sxmlData := sxmlData + '<MobileHardwareVersion xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">String content</MobileHardwareVersion>' + CRLF;
	sxmlData := sxmlData + '<WebBrowserVersion xmlns="http://schemas.datacontract.org/2004/07/Tucson.Geocaching.WCF.API.Geocaching.Types">String content</WebBrowserVersion>' + CRLF;
	sxmlData := sxmlData + '</DeviceInfo>' + CRLF;
	sxmlData := sxmlData + '</GetYourUserProfileRequest>' + CRLF;
	//
	//Log(sxmlData);
	//
{$IFNDEF GCAPI_1}
	Xml := TJclSimpleXML.Create;
	try
                if not (DirectoryExists(GEOGET_SCRIPTDIR + CalcGSAPI_sModuleTmp)) then begin
                        if not (ForceDirectories(GEOGET_SCRIPTDIR + CalcGSAPI_sModuleTmp)) then begin
                                msg :='ERR: '+_('Could not create directory: ') + GEOGET_SCRIPTDIR + CalcGSAPI_sModuleTmp;
                                AddError(msg);
                                exit;
                        end;
                end;
                //file
                f := 'GetYourUserProfile'+GlobalVarGet('Profile',false)+'.txt';
                m := 0; //zapsat do TMP
                if FileExists(GEOGET_SCRIPTDIR + CalcGSAPI_sModuleTmp + f) then begin
                        dt := GetFileTime(GEOGET_SCRIPTDIR + CalcGSAPI_sModuleTmp + f);
                        s := FileToString(GEOGET_SCRIPTDIR + CalcGSAPI_sModuleTmp + f);
                        //
                        Log('Delay: '+IntToStr(4-round(double(Now - dt) * 24))+' hour');
                        if round(double(Now - dt) * 24) < 4 then begin          //4 hodiny delay ne se natou nov data pro API
                                n := 0;                                                                 //zpracovat
                                m := 1;                                                                 //zruit zpis do TMP
                                sxmlRes := s;                                                           //pouiju data ze zlohy (TEMP)
								Log('Data from temp file: '+ GEOGET_SCRIPTDIR + CalcGSAPI_sModuleTmp + f);
                        end
                        else        
                                n := GCliveCall(0, 'GetYourUserProfile', '', sxmlData, sxmlRes);        //Z API
                end
                else
                        n := GCliveCall(0, 'GetYourUserProfile', '', sxmlData, sxmlRes);                //Z API
		//
		if n = 0 then begin
			//Log(sxmlRes);
                        //		
			Xml.LoadFromString(sxmlRes);
			for i:=0 to XML.Root.Items.count-1 do begin
				//vezmu prvni blok
				e:=XML.Root.Items[i];
				//Log('RootE: ' + e.name);
				if e.name = 'Profile' then begin
					for j:=0 to e.Items.count-1 do begin
						se := e.Items[j];
						//Log('sE: ' + se.name);
						Case se.name of
							'FavoritePoints': 	CalcGSAPI_ParseFP(se);
							'Geocaches':		CalcGSAPI_ParseCaches(se);
							//'PublicProfile':	CalcGSAPI_ParseProfile(se);
							'Souvenirs':		CalcGSAPI_ParseSouvenirs(se);
							'Stats':			CalcGSAPI_ParseStats(se);
							'Trackables':		CalcGSAPI_ParseTrackables(se);
							'User':				CalcGSAPI_ParseUser(se);
						end;
					end;
				end;				
			end;
			if m = 0 then begin 
                                if FileExists(GEOGET_SCRIPTDIR + CalcGSAPI_sModuleTmp + f) then begin
                                        if DeleteFile(GEOGET_SCRIPTDIR + CalcGSAPI_sModuleTmp + f) then
                                                StringToFile(sxmlRes,GEOGET_SCRIPTDIR + CalcGSAPI_sModuleTmp + f);
                                end
                                else
                                        StringToFile(sxmlRes,GEOGET_SCRIPTDIR + CalcGSAPI_sModuleTmp + f);
                        end;
		end
		else begin
			//error;
		end;
		//------------------------------------------------------------------------------------------
		//------------------------------------------------------------------------------------------
		//------------------------------------------------------------------------------------------
	finally
		StatorBusy('CalcGSAPI: stop');
		Xml.Free();
	end;
{$ENDIF}
{$IFDEF GCAPI_1}
	//FP
	GlobalVarSet('CalcGS_FPPercentCompletedToNextPoint','0');
	GlobalVarSet('CalcGS_FPPointsAvailable','0');		
	GlobalVarSet('CalcGS_FPTotalPoints','0');	
	GlobalVarSet('CalcGS_FPTotalUntilNextPoint','0');
	//Benchmarky/nlezy a dal
	GlobalVarSet('CalcGS_GeocachesBenchmarkCountByType','0');
	GlobalVarSet('CalcGS_GeocachesFindCountByType','0');
	GlobalVarSet('CalcGS_GeocachesFindCount','0');
	GlobalVarSet('CalcGS_GeocachesHideCountByType','0');
	GlobalVarSet('CalcGS_GeocachesHideCount','0');
	//Souvenirs
	GlobalVarSet('CalcGS_SouvenirsCount','0');
	GlobalVarSet('CalcGS_Souvenirs','');
	//
	GlobalVarSet('CalcGS_StatActiveCaches','0');
	GlobalVarSet('CalcGS_StatActiveCountries','0');
	//TB/GC
	GlobalVarSet('CalcGS_TrackablesFoundCount','0');
	GlobalVarSet('CalcGS_TrackablesFindTypeCount','0');
	GlobalVarSet('CalcGS_TrackablesFoundCountByType','0');
	GlobalVarSet('CalcGS_TrackablesOwnedCount','0');
	GlobalVarSet('CalcGS_TrackablesOwnedTypeCount','0');
	GlobalVarSet('CalcGS_TrackablesOwnedCountByType','0');
	GlobalVarSet('CalcGS_TrackablesTBCount','0');
	GlobalVarSet('CalcGS_TrackablesGCCount','0');
	//Rzn uivatelsk...
	GlobalVarSet('CalcGS_UserAvatarUrl','');
	GlobalVarSet('CalcGS_UserFindCount','0');
	GlobalVarSet('CalcGS_UserGalleryImagesCount','0');
	GlobalVarSet('CalcGS_UserHideCount','0');
	GlobalVarSet('CalcGS_UserHomeCoordinates','');
	GlobalVarSet('CalcGS_UserID','');
	if GEOGET_OWNERPREMIUM then s := 'Premium' else s:= 'Basic';
	GlobalVarSet('CalcGS_UserMemberType',s);
	GlobalVarSet('CalcGS_UserPublicGuid','');
	GlobalVarSet('CalcGS_UserName',GEOGET_OWNER);
	//
{$ENDIF}
	Log('End of CalcGSAPI_Run()');
end;