//hlavni funkce modulu
function FindsInIcons_Run(aPar:TStringList):string;
var sSql,s,sAlt,sBkg:string;
    aBkg:array [0..41] of string;    //od roku 2001 do 2020
    i,iRokMin,iRokMax,iLastYear:integer;
    tab: TSqliteTable;
    bSvetloTma,bRokySamostatne:boolean;
begin
  Result:='';
  if(aPar.Values['Title']<>'') then Result:=ProcessCommand('CmdTitle',aPar);
  Result:=Result+'<div id="iIconList" style="display:inline-block; width:100%; margin:0px; padding:0px; text-align:center;">'+CRLF;
  //nastavime barvy pro jednotlive roky, vzdy pro svetlo a pro tmu na kazdy rok
  bSvetloTma:=(aPar.Values['SvetloTma']='Yes');
  bRokySamostatne:=(aPar.Values['YearsSeparately']='Yes');
  iRokMin:=-1;
  s:=aPar.Values['ColorYears'];
  if(Fetch(s,'-')<>'Yes') then begin
    for i:=0 to 20 do begin 
      aBkg[i*2]:=GlobalVarGet('ColorMainBkg',false);
      aBkg[i*2+1]:='#aaaaaa';
    end;
  end
  else begin
    aBkg[ 0]:='';   aBkg[1]:='';   aBkg[2]:='';   aBkg[3]:='';   //2001,2
    aBkg[ 4]:='';   aBkg[5]:='';   aBkg[6]:='';   aBkg[7]:='';   //2003,4
    aBkg[ 8]:='#f9eacb'; aBkg[ 9]:='#f1d08b'; aBkg[10]:='#cbf9ce'; aBkg[11]:='#adc4ae'; //2005,6
    aBkg[12]:='#fcebfc'; aBkg[13]:='#e4bae3'; aBkg[14]:='#dce6fb'; aBkg[15]:='#b3c0db'; //2007,8
    aBkg[16]:='#dbfad0'; aBkg[17]:='#aed69e'; aBkg[18]:='#fbe5dc'; aBkg[19]:='#dbbeb3'; //2009,10
    aBkg[20]:='#eef593'; aBkg[21]:='#d3e02c'; aBkg[22]:='#f0b7f0'; aBkg[23]:='#d88fd8'; //2011,12
    aBkg[24]:='#f5deb3'; aBkg[25]:='#f4a460'; aBkg[26]:='#cfeded'; aBkg[27]:='#acc8c8'; //2013,14
    aBkg[28]:='#cbf9ce'; aBkg[29]:='#adc4ae'; aBkg[30]:='#fcebfc'; aBkg[31]:='#e4bae3'; //2015,16
    aBkg[32]:='#dce6fb'; aBkg[33]:='#b3c0db'; aBkg[34]:='#dbfad0'; aBkg[35]:='#aed69e'; //2017,18
    aBkg[36]:='#fbe5dc'; aBkg[37]:='#dbbeb3'; aBkg[38]:='#eef593'; aBkg[39]:='#d3e02c'; //2019,20
    aBkg[40]:='#e2ade2'; aBkg[41]:='#d88fd8';                             //2021,22
  end;

  //napred zjistime prvni a posledni rok, abychom mohli vytvorit hlavicku
  //a pak mohli kazdou ikonku hned zapsat a nemuseli porad pridavat ke stringu
  sSql:='SELECT MIN(dtfound) mi, MAX(dtfound) mx FROM geocache gc WHERE gc.dtfound>0 AND '
    +sCachePrefixForSql+SetSqlFilter(aPar);
  tab:=Geoget_DB.GetTable(sSql, false);
  try
    iRokMin:=StrToInt(copy(tab.FieldByName['mi'],1,4))-2001;
    iRokMax:=StrToInt(copy(tab.FieldByName['mx'],1,4))-2001;
  finally
    tab.Free();
  end;
  Log('SQL - doplneni zahlavi');
  if(aBkg[16]<>aBkg[18]) then begin //pokud jsou zobrazene roky s ruznym pozadim
    if(bSvetloTma) then Result:=Result+'<div style="margin-bottom:5px;">'+_('Finds at night have darker background.')+'</div>';
    Result:=Result+'<p style="font-size:12px; font-weight:bold;">';
    for i:=iRokMin to iRokMax do begin
      if(not bSvetloTma) then begin
        Result:=Result
          +'&nbsp;&nbsp;<span style=" padding:0px 3px 0px 3px; background-color:'+aBkg[2*i]+';">'+IntToStr(i+2001)+'</span>';
      end
      else begin
        Result:=Result
          +'<span style="margin:5px 0px 5px 5px; background-color:'+aBkg[2*i]+';">20</span>'
          +'<span style="margin:5px 5px 5px 0px; background-color:'+aBkg[2*i+1]+';">'+FormatFloatDot('0#',1.01+i)+'</span>&nbsp;&nbsp;';
      end;
    end;
    if(not bSvetloTma) then begin
      Result:=Result
        +'&nbsp;&nbsp;<span style=" padding:0px 3px 0px 3px; background-color:#ff0000;">Terrain=5</span>';
    end
    else begin
      Result:=Result
        +'<span style="margin:5px 0px 5px 5px; background-color:#ffaaaa;">Terr</span>'
        +'<span style="margin:5px 5px 5px 0px; background-color:#ff0000;">ain=5</span>&nbsp;&nbsp;';
    end;
    Result:=Result+'</p><br /><br />';
  end;
  Output(Result);
  Result:='';

  //ziskame skutecna data, z kterych tvorit ikonky
  sSql:='SELECT st.rowid poradi, gc.id id'
    +', replace(replace(gc.name,">",">"),"''","&apos;") name' 
    +', gc.dtfound dtfound, substr(dtfound,7,2)||"."||substr(dtfound,5,2)||"."||substr(dtfound,1,4) dt'
    +', substr("000"||gc.dtfoundtime,-4,2)||":"||substr("000"||gc.dtfoundtime,-2,2) dtm'
    +', gc.cachetype cachetype, gc.difficulty difficulty, gc.terrain terrain';
  if(bSvetloTma) then sSql:=sSql+',tag.SvetloTma SvetloTma'
  else sSql:=sSql+',"?" SvetloTma';
  sSql:=sSql+' FROM geocache gc, '+TEMP_TABLE+' st';
  //SvetloTma MUSI byt v apostrofech, pokud to dam do uvozovek, dela to nesmysly
  if(bSvetloTma) then sSql:=sSql+',('
    +' SELECT gt.id,gtv.value SvetloTma, gtc.value category'
    +' FROM geotag gt, geotagcategory gtc, geotagvalue gtv'
    +' WHERE gtc.key=gt.ptrkat and gtc.value=''SvetloTma'''
    +'   and gtv.key=gt.ptrvalue'
    +' ) tag';
  sSql:=sSql+' WHERE gc.id=st.id';
  if(bSvetloTma) then sSql:=sSql+' and tag.id=st.id';
  sSql:=sSql+SetSqlFilter(aPar)+' ORDER BY st.rowid';
  Log('SQL - Start');
  tab:=Geoget_DB.GetTable(sSql, false);
  Log('SQL - Zpracovani vysledku');
  iLastYear:=-1;
  try
    while not tab.eof do begin
      sAlt:='#'+tab.FieldByName['poradi']+' '+tab.FieldByName['id']+' - '
        +ReplaceString(UtfToAnsi(tab.FieldByName['name']),'"','&quot;')
        +' ('+tab.FieldByName['dt']+' '+tab.FieldByName['dtm'];
      if(bSvetloTma) then sAlt:=sAlt+' '+tab.FieldByName['SvetloTma'];
      sAlt:=sAlt+')';
      //index barvy pozadi podle roku
      i:=2*(StrToInt(copy(tab.FieldByName['dtfound'],1,4))-2001);
      //pokud mame oddelit roky a je novy rok, oddelime jej
      if(bRokySamostatne) and (i<>iLastYear) then begin
        //vytvorime novy nadpis
        aPar.Values['Title']:=IntToStr(2001+i/2);
        Output(ProcessCommand('CmdTitle',aPar));
        iLastYear:=i;
      end;
      //index barvy pozadi podle tmy
      if(tab.FieldByName['SvetloTma']='Tma') then Inc(i);
      sBkg:=aBkg[i];
      //upravit barvu pozadi podle terenu
      if(tab.FieldByName['terrain']='5') then begin
        if((i mod 2)=1) then sBkg:='#ff0000'
        else sBkg:='#ff7777';
      end;
      //pokud si nahradu delam sam a rovnou i prevedu kazdou kesku do vystupniho
      //kodovani a zapisu do vystupu, je to 20x rychlejsi nez kdyz vratim
      //cely vysledek v Result a pak se zpracuje funkci Output()
      s:='<a href="https://coord.info/'+tab.FieldByName['id']+'" target="StatorCache">'
        +'<img src="'
        +GlobalVarGet('IconCacheTypeSmall'+tab.FieldByName['cachetype'],false)+'"'
        +CRLF+'  Title="'+sAlt+'" style="';
      //barvu pozadi pridame jen kdyz je odlisna od zakladniho
      if(sBkg<>aBkg[0]) then s:=s+'background-color:'+sBkg+'; ';
      //wherigo ma vysku 17px, proto nastavime rozmer ikony na 16px
      if(tab.FieldByName['cachetype']='Wherigo Cache') then s:=s+'height:16px; width:16px;';
      s:=s+'" /></a>';
      //pro usporu casu si vystup udelame sami, aby nebylo potreba prevadet a kopirovat
      //stringy mnohokrat
      if(UpperCase(sOutCoding)<>'ANSI') then s:=UtfToCharset(AnsiToUtf(s),sOutcoding);
      if(fOut<>nil) then fOut.Write(s,Length(s));
      tab.Next();
    end;
  finally
    tab.free;
  end;
  s:=CRLF+'</div>'+CRLF;
  fOut.Write(s,Length(s));
end;